;--------------------------------------------
;       DisplayEquip    
;--------------------------------------------
DisplayEquip    PROC   near
               push    ROW
               push    COLUMN

                dec     ROW
                dec     ROW
                mov     COLUMN,68
                mov     dx,offset msg_equip1
                call    _puts
                inc     ROW
                mov     COLUMN,68
                mov     dx,offset msg_equip2
                call    _puts
                mov     al,CheckFlags
                and     al,00011111b
                mov     ah,0
                mov     cx,5
                call    digitbit

                inc     ROW
                mov     COLUMN,68
                mov     dx,offset msg_equip3
                call    _puts

                mov     cx,4
                mov     ah,0
                mov     al,equip ; Internal IDE,SCSI,SND BIOS enable
                shr     al,cl
                mov     ah,0
                call    digitbit
                mov     dx,offset msg_b_CRLF
                call    _puts
               pop     COLUMN
               pop     ROW
                ret
DisplayEquip    ENDP
msg_b_CRLF      DB     0E1h,"b",13,10,0
msg_equip1      DB     0E1h,"BIOS ׸",0
msg_equip2      DB     0E1h,"\",0
msg_equip3      DB     0E1h," ",0

;------------------------------------------------------------
;       ResoModeCheck   ŏɂP񂾂Ăяo`FbN
;------------------------------------------------------------
ResoModeCheck   PROC    near
                mov     MemWindowAddr,0Ch
                mov     MemWindowNative,08h
                mov     mem_bank_IOaddr,0461h
                mov     SegPhysIDEBIOS,0D800h   ; IDE BIOS (physical)
                mov     SegMMapIDEBIOS,9800h    ; IDE BIOS on memory window
                xor     ax,ax
                mov     es,ax
                mov     cl,es:[0455h]
                mov     ch,es:[045Dh]
                mov     al,es:[0501h]           ; hi-reso check
                and     al,8    ; 1000b           1      0
                shr     al,1    ;   
                shr     al,1    ;   10b                  0
                add     MemWindowAddr,al        ; 0Eh    0Ch
                shr     al,1    ;    1b
                mov     flagset,al      ; high/low mode flag
                mov     dx,0A000h       ; Text VRAMZOg
                mov     bx,0F8E8h       ; Machine ID i[ZOg(BIOS)
                mov     ah,00h          ; AH bit 7MAchine ID̈ꕔɎg
                or      al,al
                jz      NormalResoMode  
; HIRESOLUTION MODE SETTINGS
                mov     mem_bank_IOaddr,0091h   ; Hireso mem-window port
                mov     MemWindowNative,10h     ;  Hireso mem-window native addr
                mov     SegPhysIDEBIOS,0E600h   ; IDE work (physical)
                mov     SegMMapIDEBIOS, 8600h   ; IDE BIOS on memory window
                mov     dx,0E000h       ; The segment of Text VRAM at H mode
                mov     bx,0FFE8h       ; The segment of Machine ID flag at H.
                mov     ah,80h          ; bit7=1 , Machine IDmnC]rbg
NormalResoMode: mov     es,dx           
                mov     SegTVRAM,dx     ; TEXT VRAMZOgLϐɊi[
                mov     Seg9821,bx
                push    ds
                mov     ds,bx
                mov     al,ds:[003Fh]   ; F8E8:003F
                mov     dl,ds:[0004h]   ; F8E8:0004 bit 5 PCI bus
                mov     dh,ds:[0003h]   ; F8E8:0003 bit 3,4,6 note
                pop     ds
                or      al,ah           ; nC]bitƍ 80h..
                mov     MachineID,al
                test    dl,00100000b    ; PCI=bit5, Redwood=bit1
                jz      @f
                or      flagset, F_PCIBUS
        @@:
                test    dl,00000010b    ; PCI=bit5, Redwood=bit1
                jz      @f
                or      flagset, F_REDWOOD
        @@:     
IF 1
                test    ch,00000100b    ; 0000[045Dh]
                jz      @f
                or      CheckFlags,ALREADY_PATCHED
        @@:
ENDIF        

                test    dh,01011000b
                jz      @f
                or      flagset, F_PCI_NOTE
        @@:
                ret
ResoModeCheck   ENDP


ifNdef IPLWARE
;--------------------------------------------------------
;       ShiftKeyCheck
;--------------------------------------------------------
ShiftKeyCheck   PROC    near
                call    wait1s
     @@:        mov     ah,02h
                int 18h
                test    al,00011001b    ; 1=SHIFT, 8=GRPH, 16=CTRL
                jnz     @b
                ret
ShiftKeyCheck   ENDP
ENDIF


IF 0
;--------------------------------------------------------
;       SetChkSum        ES:0   ES=RAMwindowIDE
;--------------------------------------------------------
SetChkSum       PROC    near
                mov     ax,SegTemp
                push    ds
                mov     ds,ax
                xor     dx,dx
                mov     si,dx
                mov     cx,(2000h/2)
                dec     cx
        @@:
                lodsw
                add     dl,al
                add     dh,ah
               loop     @b
                neg     dl
                neg     dh
                mov     ds:[si],dx
                pop     ds
                ret
SetChkSum       ENDP
ENDIF

IFnDEF  IPLWARE
;--------------------------------------------------------------+-----------+
;       Scan_GRPH_FK  [FE1]`[FE7]L[Ń[hIEL   | 2024/12/01|
; L[Ԃ݂    keycode   e[h̊OlɑΉ | 15,16head |
;--------------------------------------------------------------+-----------+
Scan_GRPH_FK_1516   PROC   near
                mov     cx,7777
        @@:     mov     ah,2
                int 18h
                test    al,00001000b    ; 1=SHIFT, 8=GRPH
                jnz     EnterValue
                test    al,00010000b    ; 16=CTRL
                jnz     CancelProgram
               loop     @b
                jmp     ScanFKEY_abort
EnterValue:     
                mov     dx,offset ExplainModeValue
                call    _puts
                mov     dx,offset EnterModeValue
                call    _puts
;;;                call    Poop            ; ````
                xor     ax,ax   ; wait while keybord input 
                int 18h         ; return: AL=key DATA, AH=key CODE
                xchg    al,ah   ; with key CODE
                or      al,al   ; [ESC]
                jz      @f
                cmp     al,62h  ; key Code 62h=[F.1] 
                jb      ScanFKEY_abort  ;  `   `
                cmp     al,68h  ; key Code 68h=[F.7]
                ja      ScanFKEY_abort
                sub     al,61h          ; -61hOlƂȂ
                and     al,00000111b    ; Mask for safety
                cmp     al,7            ; [F7]Cancel
                je      CancelProgram   ; 
       @@:      mov     ModeID,al       ; [hlm肷
                
                push    ax
;;;                call    Poop            ; ````
                mov     al,0Dh          ; XCb`\ɂ
                out 68h,al
                pop     ax
                mov     COLUMN,0        ; JOɂ
                mov     bx,3FF6h        ; XCb`U
                mov     ah,es:[bx]      ; XCb`Uǂݍ
                and     ah,11111000b    ; ̃rbgۑ̃}XN
                or      al,ah
                mov     es:[bx],al      ; XCb`Uɏ
                mov     al,0Ch          ; XCb`֎~ɂ
                out 68h,al
ScanFKEY_abort: mov     al,ModeID
                clc
                ret
CancelProgram:  mov     al,0
                stc
                ret
ExplainModeValue DB     0A1h,"[F1]=16:63,  [F2]=8:17,  [F3]=15:63  [F4]=16:32  [F7]Cancel",13,10,0  
EnterModeValue  DB      0A3h,"IDE ޲̕H:SҰ I ==> [F1]`[F4] or [F7]",13,10,0
Scan_GRPH_FK_1516   ENDP
;----------------------------------------------------------------
CheckMemSwitch  PROC   near
; XCb`̐ݒ݂
                mov     es,SegTVRAM
                mov     al,es:[3FF6h]   ; XCb`U̎w
                and     al,00000111b    ; }XN
                or      al,al           ; XCb`ÔƂftHg
                jnz     ValidMEMSW      ; XCb`̒l͊Ol
                mov     al,1            ; ModeID,1        ; default=1
ValidMEMSW:     mov     ModeID,al       ; XCb`gpȂ炻ɏ]
                mov     bl,al
                cmp     bl,7            ; l>=7ȂLZ
                jb      @f
                stc
                ret
        @@:
                shl     bl,1    ; 
                shl     bl,1    ; *4{
                mov     bh,0    ; AhXItZbg
                add     bx,offset ModeNamePtr
                mov     dx,[bx] ; \
                mov     ax,[bx+2]
                mov     SECTOR_N,al
                mov     HEAD_N,ah
                call    _puts
                clc
                ret

ModeNamePtr     DW      offset  Mode1Name
                DB      63,16
                DW      offset  Mode1Name
                DB      63,16
                DW      offset  Mode2Name
                DB      17,8
                DW      offset  Mode3Name
                DB      63,15
                DW      offset  Mode4Name
                DB      32,16
                DW      offset  Mode5Name
                DB      32,8
                DW      offset  Mode6Name  ; Bݒ
                DB      32,128
Mode1Name       DB      0E1h,"HEAD 16, SECTOR 63 (ftHg)",13,10,0
Mode2Name       DB      0E1h,"Head  8, Sector 17 (BIOSƈvҰ)",13,10,0
Mode3Name       DB      0E1h,"Head 15, Sector 63 (ꕔSSD,HDD)",13,10,0
Mode4Name       DB      0E1h,"Head 16, Sector 32 (ÂCFɂ)",13,10,0
Mode5Name       DB      0E1h,"Head  8, Sector 32 (8GBSCSI݊)",13,10,0
Mode6Name       DB      0E1h,"Head  8, Sector128 (32GBSCSI݊)",13,10,0
CheckMemSwitch  ENDP
ENDIF

ifNdef  IPLWARE
;--------------------------------------------------------
;       SetTone         
;--------------------------------------------------------
SetTone         PROC   near             ; ax= tone
                push    dx
                mov     DX,03FDBh       ; 3FDB
                out     DX,AL
                out     5Fh,al
                xchg    AL,AH
                out     DX,AL
                out     5Fh,al
                pop     dx
                ret
SetTone         ENDP
ENDIF


;--------------------------------------------------------
;       GetDisplayLine       input   ES = VRAM segment
;--------------------------------------------------------
GetDisplayLine  PROC    near
                mov     ax,0060h
                push    ds
                mov     ds,ax
                mov     al,ds:[0110h]
                pop     ds
                cmp     al,0
                je      default_line
                cmp     al,15
                jb      @f
default_line:   mov     al,13
        @@:     add     al,2
                mov     ROW,ax
                ret
GetDisplayLine  ENDP

;----------------------------------------------------------------
;       PeriEnvCheck ( equiped peripherals ) Ap3,As3,BA3,BX3 only
; port F0h      1= HDD/IF Ȃ ,  0=HDD/IF  _
; bit 6: ^Cv(SCSI)HDDXe[^X            40h 
; bit 5: ^Cv(SASI,IDE)HDDXe[^X        20h
;I/O  00F0h   }VXe[^Xǂݏo^CPUVbg_E
;bit 7: CPUx聡[PC-9821ApAsAeAf]  1=High or Low, 0=Middle
;bit 6: ^Cv(SCSI)HDDXe[^X 1= 55^CvHDDȂ
;bit 5: ^Cv(IDE)HDDXe[^X 1= IDE HDDȂ
;bit 3: RAMANZX 1= W܂͊gXbg
;I/O  841Fh   DIP SWITCHǂݏo
;bit 1: SOUND BIOS   1=use SOUND BIOS  ,  0=release SOUND BIOS
;I/O  8F1Eh   DIP SWITCHǂݏo
;bit 0: 15-16MBԃVXegpL  0=system use  1=RAM use
;----------------------------------------------------------------
PeriEnvCheck    PROC    near
                in      al,0F0h
;                test    al,20h          ; Internal SASI/IDE exist?
;                jnz     noequip_ide    ; ̃vOIDE BIOS݂Ȃ
;                jnz     IDE_absent     ; Ƃ̂͂蓾.
                OR      equip,IDE_equip ; IDE BIOS o
                OR      CheckFlags,IDE_IF ; IDE BIOS ability
noequip_ide:    

               test   CheckFlags,SCSI_IF   ; SCSI@ł͗LɂȂ
               jz       noequip_E10_FA02
                test    al,40h          ; SCSI(A-mate)݂͑邩?
                jnz     noequip_E10_FA02
                OR      equip,E10_equip ; SCSI BIOS L
noequip_E10_FA02:

                test    flagset,F_HIRESO ; nC]Ȃ疳
                jnz     end_check_sndbios ; SOUND BIOS݂͑ȂƂ
;int 3
               test  CheckFlags,SND_DSW ; SDIPSWɂ@iA-matesj
               jz       @f
                mov     dx,841Eh        ; DIP switch 𒲂ׂɍs@g
                in      al,dx
                test    al,02h          ; bit 1: Undoc2 ƈႤ̂Œ
                jz      end_check_sndbios ; Ap,As,Aeł͕ʂ̌o@I
                or      equip,SND_equip ; TEhBIOSL
                jmp     end_check_sndbios ; Ap,As,Aeł͕ʂ̌o@I
        @@:
.386
               test  CheckFlags,SND_AM1 ; A-mateL
               jz       No_amate1_sound_bios
                mov     ax,0CC00h
                mov     es,ax
                mov     eax,5557561Eh
                cmp     es:[0],eax
                jne     No_amate1_sound_bios ; SOUND BIOS    2025/1/27
                or      equip,SND_equip ;L
.186
No_amate1_sound_bios:

end_check_sndbios:  
                ; SASI BIOSׂ͒ȂiDISKڑUNITgp֎~j
                clc
                ret
IDE_absent:     stc
                ret
PeriEnvCheck    ENDP

.386
;--------------------------------------------------------
;       CheckNotePCI     2024/12/20
;--------------------------------------------------------
CheckNotePCI    PROC   near
                mov     es,SegPhysIDEBIOS       ; D800:
                mov     NoteWorkAreaHi,26h
                mov     bh,NoteWorkAreaHi
                mov     bl,0
                mov     di,bx
                mov     eax,es:[di+0]
                or      eax,eax
                jz      @f
                jmp     PCI_Note_end
        @@:
                mov     NoteWorkAreaHi,22h
                mov     bh,NoteWorkAreaHi
                mov     bl,0
                mov     di,bx
                mov     eax,es:[di+0]
                or      eax,eax
                mov     NoteWorkAreaHi,20h; 
                stc
                ret
PCI_Note_end:
                clc
                ret
CheckNotePCI    ENDP
.8086

;--------------------------------------------------------
;       Exist_IDE_BIOS
;--------------------------------------------------------
Exist_IDE_BIOS  PROC   near
                push    ds
                mov     ds,SegPhysIDEBIOS
                mov     ax,ds:[0009h]   ; ? C-BUS ROM
                mov     cl,ds:[000Bh]   ; ? C-BUS ROM
                mov     dx,ds:[0030h]  ; ? $PnP
                pop     ds
                cmp     ax,0AA55h       ; C-BUS ROM signature
                jnz     NoExist_IDE_BIOS
                cmp     cl,2Ah          ; C-BUS ROM type ID (2A)
                je      Exist_IDEBIOS
                cmp     cl,3Ah          ; C-BUS ROM type ID (3A) for Black NOTE
                je      Exist_IDEBIOS
NoExist_IDE_BIOS:  
                mov     dx,offset absent_msg
                call    _puts
                stc
                ret
Exist_IDEBIOS:
                or      dx,dx         ; jmp [0030] == 00000000h
                jz      NoExist_IDE_BIOS
                clc
                ret
Exist_IDE_BIOS  ENDP

;--------------------------------------------------------------------
;       scan_pattern    ̔r[`    for IDE BIOS
;       <input> costumized
;       DS:SI rp^[,         CX p^[̃oCg
;       ES:DI p^[ꏊ
;       <output>        < j AX,BX,CX,DX,DI >
;       CY =NONE ,  NC= ES:BX   carry0̂Ƃ  ES:BXɌoꏊԂ
;--------------------------------------------------------------------
scan_pattern    PROC    near
                cld
                mov     di,0040h
                mov     dx,2000h-80h
;;                sub     dx,cx
                mov     bx,0

scan_ent:       mov     ax,ds:[si]
                cmp     ax,es:[di]
                jnz     scan_No_match
                mov     bx,di
                push    cx
                push    si
                push    di
         repz   cmpsb
                or      cx,cx
                mov     CallAddr256BS,di   ; added for FIXIDECF on 2025/1/26
                pop     di
                pop     si
                pop     cx
                jnz     scan_No_match
                clc                     ; scan OK
                ret
scan_No_match:  inc     di
                cmp     di,dx
                jb      scan_ent
                stc                     ; scan NG
                ret
scan_pattern    ENDP


ifNdef  IPLWARE
IF 0
;--------------------------------------------------------
;       Poop
;--------------------------------------------------------
Poop            PROC   near
                mov     ax,4400       ; low freq.
                call    SetTone
                mov     al,6            ; BEEP ON
                out 37h,al              
                mov     cx,5432h 
        @@:     out     5Fh,al  ; ҂
                out     5Fh,al
               loop     @b
                mov     al,7            ; BEEP OFF
                out 37h,al              
                mov     ax,04CDh        ; normal freq.
                call    SetTone
                call    wait1s
                ret
Poop            ENDP
ENDIF
ENDIF

;--------------------------------------------------------
wait1s          PROC   near
                mov     cx,9821h 
        @@:     out     5Fh,al  ; ҂
                out     5Fh,al
                out     5Fh,al
               loop     @b
wait1s          ENDP
;--------------------------------------------------------
;       ClearSegTemp
;--------------------------------------------------------
ClearSegTemp    PROC    near
                push    es
                mov     cx,4000h/2
                mov     ax,SegTemp
                mov     es,ax
                xor     ax,ax
                mov     di,ax
           rep  stosw
                pop     es
                ret
ClearSegTemp    ENDP
;=========================================
