NEW_PATCH_1B30h         equ     1B30h
Ptn4R_IDP_Head  label   word
        or      byte ptr es:[2004h],07h  ;26 80 0E 04 26 07
Ptn4R_IDP_Head_end  label   word

Code4R_LBACHS_div  label word
        DB      51h                       ;push    cx      ; BX=2100h +00h,+20h,+40h,+60h drive num
        DB      26h,8Bh,4Fh,08h           ;mov     cx,es:[bx+08h]  ; H*S
        DB      0F7h,0F1h                 ;div     cx      ; /(H*S)
        DB      26h,0A3h,02h,20h          ;mov     es:[2002h],ax   ;+10 AX=cylinder addr
        DB      33h,0C9h                  ;xor     cx,cx   ; CH=0
        DB      26h,8Ah,4Fh,07h           ;mov     cl,es:[bx+07h]  ; S
Code4R_LBACHS_div_end  label word
;       DB      8Bh,0C2h                  ;mov     ax,dx   ; AX is the remnant. 
;       DB      33h,0D2h                  ;xor     dx,dx
;       DB      0F7h,0F1h                 ;div     cx      ; /H
;       DB      26h,80h,26h,04h,20h,0F0h  ;and     byte ptr es:[2004h],0F0h ; Dev/H reg is CHS mode
;       DB      26h,08h,06h,04h,20h       ;or      es:[2004h],al   ; =head addr
;       DB      0FEh,0C2h                 ;inc     dl
;       DB      26h,88h,16h,05h,20h       ;mov     es:[2005h],dl   ; =sect addr
;       DB      59h                       ;pop     cx
;       DB      26h,88h,0Eh,0Ah,20h       ;mov     es:[200Ah],cl   ; 
;       DB      0C3h                      ;ret     


Pat4R_LBACHS_div  label word
        DB      51h                       ;push    cx      ; BX=2100h +00h,+20h,+40h,+60h drive num
        DB      26h,8Bh,4Fh,0Ch           ;mov     cx,es:[bx+0Ch]  ; H*S
        DB      0F7h,0F1h                 ;div     cx      ; /(H*S)
        DB      26h,0A3h,02h,20h          ;mov     es:[2002h],ax   ;  =cylinder addr
        DB      33h,0C9h                  ;xor     cx,cx   ; CH=0
        DB      26h,8Ah,4Fh,0Eh           ;mov     cl,es:[bx+0Eh]  ; S
Pat4R_LBACHS_div_end  label word
;        DB      8Bh,0C2h                  ;mov     ax,dx   ; AX is the remnant. 
;        DB      33h,0D2h                  ;xor     dx,dx
;        DB      0F7h,0F1h                 ;div     cx      ; /H
;        DB      26h,80h,26h,04h,20h,0F0h  ;and     byte ptr es:[2004h],0F0h ; Dev/H reg is CHS mode
;        DB      26h,08h,06h,04h,20h       ;or      es:[2004h],al   ; =head addr
;        DB      0FEh,0C2h                 ;inc     dl
;        DB      26h,88h,16h,05h,20h       ;mov     es:[2005h],dl   ; =sect addr
;        DB      59h                       ;pop     cx
;        DB      26h,88h,0Eh,0Ah,20h       ;mov     es:[200Ah],cl   ; 
;        DB      0C3h                      ;ret     

Code4R_SetParam label   word
        DB      26h,8Bh,45h,0Ch         ;mov     ax,es:[di+0Ch]
        DB      86h,0E0h                ;xchg    ah,al
        DB      26h,8Bh,4Dh,06h         ;mov     cx,es:[di+06h]
        DB      86h,0E9h                ;xchg    ch,cl
        DB      0F7h,0E1h               ;mul     cx
Code4R_SetParam_end label   word

Pat4R_SetParam label   word
                push    si
                mov     si,NEW_PATCH_1B30h
                call    si
                pop     si
                DB      7 dup (90h)     ; NOP*7
Pat4R_SetParam_end label   word

New4R_SetParam label   word
                mov     ax,es:[di+0Ch]  ; sect?
                xchg    ah,al
                mov     es:[bx+0Eh],al
                mov     cx,es:[di+06h]   ; head
                xchg    ch,cl
                mov     es:[bx+0Fh],cl
                mul     cx
                mov     es:[bx+0Ch],ax  ; H*S
                ret
New4R_SetParam_end label   word

Ptn4R_IDP    label   word
         DB      26h,80h,7Fh,07h,11h     ;cmp   byte ptr es:[bx+07],11;
         DB      75h                    ;jnz   0401 @f
Ptn4R_IDP_end    label   word
;        DB      1Eh                 ;jnz   0401 @f
;        DB      26h,0C6h,06h,00h,20h,07h ;mov  byte ptr es:[2000],07
;        DB      26h,0C6h,06h,01h,20h,00h ;mov  byte ptr es:[2001],00
;        DB      26h,0C6h,06h,0Ah,20h,11h ;mov  byte ptr es:[200A],11; 17sect
;        DB      0E8h,18h,08h             ;call 0C10
;        DB      26h,80h,0Eh,04h,20h,07h  ;or   byte ptr es:[2004],07;8head-1
;        DB      0E8h,0E0h,08h            ;call 0CE1

pattern4R_patch PROC   near
                test    flagset,F_PCI_NOTE
                jz      @f
                mov     al,NoteWorkAreaHi

                mov     si, offset Code4R_LBACHS_div    ;fixed V1.45
                mov     ds:[si+10],al   ; Note [2600] ;fixed V1.41
                mov     si, offset Pat4R_LBACHS_div
                mov     ds:[si+10],al   ; 
                
                mov     si, offset Ptn4R_IDP_Head
                mov     ds:[si+4],al    ;
                
                mov     si, offset Ptn_IDP_Sect
                mov     ds:[si+4],al    ;
                mov     ds:[si+10],al    ;
                mov     ds:[si+16],al    ;
        @@:     
;(1)----
                mov     si, offset Code4R_LBACHS_div
                mov     cx, offset Code4R_LBACHS_div_end 
                sub     cx, si
                call    scan_pattern
                jc      pattern4R_not_found
                mov     di,bx
                mov     si, offset Pat4R_LBACHS_div
                mov     cx, offset Pat4R_LBACHS_div_end 
                sub     cx, si
        rep     movsb
;(2)----
                mov     si, offset Code4R_SetParam 
                mov     cx, offset Code4R_SetParam_end
                sub     cx, si
                call    scan_pattern
                jc      pattern4R_not_found
                mov     di,bx
                mov     si, offset Pat4R_SetParam 
                mov     cx, offset Pat4R_SetParam_end
                sub     cx, si
        rep     movsb
                mov     di,NEW_PATCH_1B30h        ; add
                mov     si, offset New4R_SetParam
                mov     cx, offset New4R_SetParam_end
                sub     cx, si
        rep     movsb

;(3)----
                mov     si, offset Ptn_IDP_Sect   
                mov     cx, offset Ptn_IDP_Sect_end
                sub     cx,si
                call    scan_pattern
                jc      pattern4R_not_found
        @@:     mov     al,SECTOR_N
                mov     es:[bx+17],al   ; sect


                mov     si, offset Ptn4R_IDP_Head
                mov     cx, offset Ptn4R_IDP_Head_end
                sub     cx, offset Ptn4R_IDP_Head
                call    scan_pattern
                jc      pattern41not_found
        @@:     mov     al,HEAD_N
                dec     al
                mov     es:[bx+5],al    ;head

.386
                mov     al,SECTOR_N
                mov     ah,HEAD_N
                push    ax
                shl     eax,16
                pop     ax
                mul     ah      ; EAX Ƀf[^  H*S, S, H 

                mov     dh,NoteWorkAreaHi ; 20,22,26
                cmp     dh,22h
                je      @f
                add     dh,01h          ; 21,23,27
                mov     dl,0Ch
                mov     di,dx
                mov     es:[di],eax  ; 210C,230C,270C
                add     di,+20h
                mov     es:[di],eax  ; 212C,232C,272C
                add     di,+20h
                mov     es:[di],eax  ; 214C,234C,274C
                add     di,+20h
                mov     es:[di],eax  ; 216C,236C,276C
        @@:
.186
ExitPatch4R:
                clc
                ret
pattern4R_not_found:
                stc
                ret
pattern4R_patch ENDP

